#include	<windows.h>
#include	<stdio.h>
#include	"common.h"
#include	"xmil.h"
#include	"x1.h"
#include	"x1_crtc.h"
#include	"x1_pcg.h"
#include	"x1_vram.h"
#include	"draw.h"
#include	"drawtxt.h"
#include	"ddraws.h"

		DWORD	text_x1_table[32][256];
		DWORD	grph_x1_table[6][256];
		DWORD	text_x2_table[16][64];
		DWORD	degitalpal[24] = {
				0x00000000, 0xfc0000ff, 0xf9ff0000, 0xfdff00ff,
				0xfa00ff00, 0xfe00ffff, 0xfbffff00, 0xffffffff,
				0x00000000, 0x00000000, 0x00000000, 0x00000000,
				0x00000000, 0x00000000, 0x00000000, 0x00000000,
				0x00000000, 0x00000000, 0x00000000, 0x00000000,
				0x00000000, 0x00000000, 0x00000000, 0x00000000};

#define	TRAM_MAX	0x800

		BYTE	updatetmp[0x800+0x101];
		BYTE	scrnflash;
		BYTE	scrnallflash;
		BYTE	doubleatrchange;
		BYTE	palandply;
		BYTE	blinkflag;
		BYTE	blinktest = 0;

extern	BYTE	screenmap[];

static	BYTE	lastdisp = 0;
static	BYTE	dispflg = UPDATE_VRAM0;
static	BYTE	*dispp = GRP_00;
static	WORD	vramsize;
static	BYTE	vramylpcnt;
static	WORD	vramylpad;
static	BYTE	blinktime = 1;
const	DWORD	deg1pal[8] = {
				0x000000, 0x000001, 0x010000, 0x010001,
				0x000100, 0x000101, 0x010100, 0x010101};

static	BYTE	ddrawflash = 0;
static	WORD	drawlines = 200;
static	BYTE	fonttype = 0;
		BYTE	fontycnt = 0;		// xmillł 8C 16C\
									// Ȃ̂ 16Cx[XƂ


										// edi  yecx 0NA
#define	text_clear														\
				__asm {	xor		eax, eax					}			\
textclrlp:		__asm {	mov		[edi], eax					}			\
				__asm {	mov		[edi+4], eax				}			\
				__asm {	add		edi, SCREEN_WIDTH*2			}			\
				__asm {	loop	textclrlp					}


void reflesh_palette(void) {

	BYTE	i;
	BYTE	v;

	v = xmilcfg.BLKLIGHT;

	if ((!xmilcfg.SKIP_LINE) || (crtc.SCRN_BITS & 1)) {
		v >>= 1;
	}
	degitalpal[0] = (deg1pal[7] * v) | ((DWORD)(START_PAL + USE_PALS) << 24);
	switch(xmilcfg.TEXT400L) {
		case 0:
			v = xmilcfg.LINEDEPTH;
			break;
		case 1:
			v = 0xff;
			break;
		default:
			v = xmilcfg.LINETEXT;
			break;
	}
	for (i=1; i<8; i++) {
		degitalpal[i+8] = deg1pal[i] * v +
						((DWORD)(START_PAL + USE_PALS + i) << 24);
	}
	for (i=1; i<8; i++) {
		degitalpal[i+16] = deg1pal[i] * xmilcfg.LINEDEPTH +
						((DWORD)(START_PAL + USE_PALS + i + 8) << 24);
	}
}


void textdrawproc_renewal(void) {

	fonttype = 0;
	if (!(crtc.SCRN_BITS & 1)) {
		if (xmilcfg.TEXTMODE) {
			fonttype = KNJ_24KHz;
		}
	}
	else {
		fonttype = ANK_24KHz | KNJ_24KHz;
	}
	scrnallflash = 1;
}


void init_draw(void) {

	BYTE	i;
	BYTE	bit;
	DWORD	work;
	WORD	pat;

	vramylpcnt = 8;
	vramylpad = 160 * 16;
	vramsize = 40*25;

	for (pat=0; pat<256; pat++) {
		for (bit=0x10; bit; bit<<=1) {
			work <<= 8;
			if (pat & bit) {
				work |= 1;
			}
		}
		grph_x1_table[0][pat] = work;
		grph_x1_table[1][pat] = work << 1;
		grph_x1_table[2][pat] = work << 2;
		for (i=0; i<8; i++) {
			text_x1_table[i][pat] = (work * i) << 3;
			text_x1_table[i+8][pat] = text_x1_table[i][pat] ^ 0x38383838;
		}

		for (bit=1; bit<0x10; bit<<=1) {
			work <<= 8;
			if (pat & bit) {
				work |= 1;
			}
		}
		grph_x1_table[3][pat] = work;
		grph_x1_table[4][pat] = work << 1;
		grph_x1_table[5][pat] = work << 2;
		for (i=0; i<8; i++) {
			text_x1_table[i+16][pat] = (work * i) << 3;
			text_x1_table[i+24][pat] = text_x1_table[i+16][pat] ^ 0x38383838;
		}
	}

	for (pat=0; pat<16; pat++) {
		for (bit=0x4; bit<0x10; bit<<=1) {
			work <<= 16;
			if (pat & bit) {
				work |= 0x0101;
			}
		}
		for (i=0; i<8; i++) {
			text_x2_table[pat][i] = (work * i) << 3;
			text_x2_table[pat][i+8] = text_x2_table[pat][i] ^ 0x38383838;
		}

		for (bit=1; bit<4; bit<<=1) {
			work <<= 16;
			if (pat & bit) {
				work |= 0x0101;
			}
		}
		for (i=0; i<8; i++) {
			text_x2_table[pat][i+16] = (work * i) << 3;
			text_x2_table[pat][i+24] = text_x2_table[pat][i+16] ^ 0x38383838;
		}
	}

	reflesh_palette();
	lastdisp = 0;
	dispflg = UPDATE_VRAM0;
	dispp = GRP_00;
}


void fillupdatetmp(void) {

		__asm {
				mov		ebx, offset updatetmp
				mov		ecx, 0x200
filludt_lp:		or		dword ptr [ebx], (UPDATE_VRAM * 01010101h)
				add		ebx, 4
				loop	filludt_lp
		}
}



static LABEL void flashupdatetmp(void) {

		__asm {
				push	ebx
				push	esi
				push	edi

				movzx	esi, crtc.TXT_TOP
				xor		dl, dl
										// ܂sׂĂc{pׂ
check_tateflag:	mov		edi, esi
				movzx	ecx, crtc.TXT_XL
tateflaglp_s:	cmp		di, TRAM_MAX
				jae		tatex2
				test	TXT_RAM[edi + TEXT_ATR], X1ATR_Yx2
				je		tatex1
				inc		di
				loop	tateflaglp_s
										// ׂďc{p 

tatex2:			movzx	ecx, crtc.TXT_XL
				shr		cl, 1

tatex2loop_s:	cmp		si, TRAM_MAX
				jae		flashupdatetmp_end
				mov		ax, (UPDATE_VRAM or 04h) * 0101h		// c{p
				mov		bx, word ptr (TXT_RAM[esi + TEXT_ATR])

				test	bl, X1ATR_Xx2
				je		tatex2_norleft
												// {ptOĂ
				or		ax, 08h + 12h * 256		// S{p + Ec{p͊m
				test	bh, X1ATR_Xx2
				je		tatex2_pcg
				or		ah, 8					// E{prbgĂ
				jmp		tatex2_pcg

tatex2_norleft:	test	bh, X1ATR_Xx2			// S{płȂꍇ
				je		tatex2_pcg
				or		ah, 8					// Êݔ{p
tatex2_pcg:		mov		bx, word ptr (updatetmp[esi])
				and		bx, UPDATE_VRAM * 0101h
				or		ax, bx					// UPDATEtO
				cmp		word ptr (updatetmp[esi]), ax
				je		tatex2noupdate
				or		ax, UPDATE_VRAM * 0101h
				mov		word ptr (updatetmp[esi]), ax
tatex2noupdate:	add		si, 2
				loop	tatex2loop_s
				jmp		nextlinecheck

tatex1:			movzx	ecx, crtc.TXT_XL
				shr		cl, 1
				xor		dh, dh
tatex1loop_s:	cmp		si, TRAM_MAX
				jae		flashupdatetmp_end
				xor		ax, ax
				mov		bx, word ptr (TXT_RAM[esi + TEXT_ATR])
				or		dh, dh					// cm[}͊ɂH
				jne		tatex1_tate_e
				test	bl, X1ATR_Yx2
				je		tatex1_tate0
				mov		al, UPDATE_VRAM or 1	// ׂc{p
				test	bh, X1ATR_Yx2
				je		tatex1_tate0
				mov		ah, UPDATE_VRAM or 1	// Eׂc{p
				jmp		tatex1_tate_e
tatex1_tate0:	inc		dh						// cm[}̏o
tatex1_tate_e:
				test	bl, X1ATR_Xx2
				je		tatex1_norleft
												// {ptOĂ
				or		ax, 08h + (12h * 256)	// {p ͊m
				test	bh, X1ATR_Xx2
				je		tatex1_pcg
				or		ah, 8					// E{prbgĂ
				jmp		tatex1_pcg

tatex1_norleft:	test	bh, X1ATR_Xx2			// {płȂꍇ
				je		tatex1_pcg
				or		ah, 8					// Êݔ{p
tatex1_pcg:		mov		bx, word ptr (updatetmp[esi])
				and		bx, UPDATE_VRAM * 0101h
				or		ax, bx
				cmp		word ptr (updatetmp[esi]), ax
				je		tatex1noupdate
				or		ax, UPDATE_VRAM * 0101h
				mov		word ptr (updatetmp[esi]), ax
tatex1noupdate:	add		si, 2
				loop	tatex1loop_s

nextlinecheck:	inc		dl
				cmp		dl, crtc.TXT_YL
				jb		check_tateflag
flashupdatetmp_end:
				pop		edi
				pop		esi
				pop		ebx
				ret
	}
}



void updateblink(void) {

		__asm {
				dec		blinktime
				jns		blinkupflg_ed
				mov		blinktime, 30-1
				push	edi
				movzx	edi, crtc.TXT_TOP
				mov		ax, 010h
				xor		blinktest, al
				mov		cx, vramsize
				or		cx, cx
				je		blinkupflg

blinkup_lp:		test	TXT_RAM[edi + TEXT_ATR], al
				je		short blinknup_ed
				mov		ah, UPDATE_VRAM
				or		updatetmp[edi], ah
blinknup_ed:	inc		edi
				dec		cx
				jne		blinkup_lp
				or		scrnflash, ah
				shr		ah, 5
blinkupflg:		pop		edi
				mov		blinkflag, ah
blinkupflg_ed:
		}
}





static LABEL void text_effect12line(void) {

	__asm {
				shl		cl, 1
				dec		cl
				mov		eax, SCREEN_WIDTH
				mul		ecx

txteffect_lp:	mov		edx, [eax+edi+0]
				mov		[eax*2+edi+SCREEN_WIDTH*0+0], edx
				mov		[eax*2+edi+SCREEN_WIDTH*1+0], edx
				mov		edx, [eax+edi+4]
				mov		[eax*2+edi+SCREEN_WIDTH*0+4], edx
				mov		[eax*2+edi+SCREEN_WIDTH*1+4], edx
				sub		eax, SCREEN_WIDTH
				jns		txteffect_lp
				ret
	}
}


static LABEL void pcg_effect12line(void) {

	__asm {
				dec		cl
				mov		eax, SCREEN_WIDTH*2
				mul		ecx
				mov		ecx, eax

pcgeffect_lp:	mov		eax, [ecx+edi+SCREEN_WIDTH*0+0]
				xor		eax, esi
				mov		[ecx*2+edi+SCREEN_WIDTH*0+0], eax
				mov		[ecx*2+edi+SCREEN_WIDTH*2+0], eax
				add		eax, ebx
				mov		[ecx*2+edi+SCREEN_WIDTH*1+0], eax
				mov		[ecx*2+edi+SCREEN_WIDTH*3+0], eax
				mov		eax, [ecx+edi+SCREEN_WIDTH*0+4]
				xor		eax, esi
				mov		[ecx*2+edi+SCREEN_WIDTH*0+4], eax
				mov		[ecx*2+edi+SCREEN_WIDTH*2+4], eax
				add		eax, ebx
				mov		[ecx*2+edi+SCREEN_WIDTH*1+4], eax
				mov		[ecx*2+edi+SCREEN_WIDTH*3+4], eax
				sub		ecx, SCREEN_WIDTH*2
				jns		pcgeffect_lp
				ret
	}
}







static void width80x25_200line(void) {			// 80x25 15Khz [h

	WORD	p;
	DWORD	*v;
	BYTE	atr, ank, knj;
	int		i;
	BYTE	newline = 0;
	BYTE	x = 0;
	int		y = 0;
	int		times;
	BYTE	*q;
	WORD	r;
	BYTE	upt;

	fontycnt = 0;
	p = crtc.TXT_TOP;
	v = (DWORD *)screenmap;

	times = vramsize;
	while((times--) && (p < TRAM_MAX)) {
		if (updatetmp[p] & dispflg) {
			updatetmp[p] ^= dispflg;
			upt = updatetmp[p];
			newline = 1;
			r = p;
			atr = TXT_RAM[r + TEXT_ATR];
			if (atr & blinktest) {
				atr ^= X1ATR_REVERSE;
			}
			if (upt & 0x10) {
				r--;
			}
			ank = TXT_RAM[r + TEXT_ANK];
			if (TXT_RAM[r + TEXT_ATR] & 0x20) {
				__asm {
					push	esi
					push	edi
					mov		edi, v
					movzx	ecx, vramylpcnt
					text_clear						// ecx = 0 ɂȂ锤

					movzx	esi, ank
					shl		si, 3
					add		esi, offset (pcg.B)
					movzx	eax, byte ptr upt
					and		al, 15
					mov		eax, pcg8effects[eax*4]

					test	atr, 1
					je		pcgplane_red
					mov		edi, v
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 1
					push	eax
					call	eax
					pop		eax

pcgplane_red:		add		si, 256*8
					test	atr, 2
					je		pcgplane_green
					mov		edi, v
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 2
					push	eax
					call	eax
					pop		eax

pcgplane_green:		add		si, 256*8
					test	atr, 4
					je		pcgplane_effect
					mov		edi, v
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 4
					call	eax
pcgplane_effect:							// XLbvCEo[X
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 0x40404040
					mov		edi, v
					test	atr, X1ATR_REVERSE
					jne		txtefct_reverse

pcgeffects1_lp:		mov		eax, [edi+SCREEN_WIDTH*0+0]		// m[}
					add		eax, edx
					mov		[edi+SCREEN_WIDTH*1+0], eax
					mov		eax, [edi+SCREEN_WIDTH*0+4]
					add		eax, edx
					mov		[edi+SCREEN_WIDTH*1+4], eax
					add		edi, SCREEN_WIDTH*2
					loop	pcgeffects1_lp
					jmp		pcgeffectend

txtefct_reverse:											// o[X
pcgeffects2_lp:		xor		dword ptr [edi+SCREEN_WIDTH*0+0], 38383838h
					mov		eax, [edi+SCREEN_WIDTH*0+0]
					add		eax, edx
					mov		[edi+SCREEN_WIDTH*1+0], eax
					xor		dword ptr [edi+SCREEN_WIDTH*0+4], 38383838h
					mov		eax, [edi+SCREEN_WIDTH*0+4]
					add		eax, edx
					mov		[edi+SCREEN_WIDTH*1+4], eax
					add		edi, SCREEN_WIDTH*2
					loop	pcgeffects2_lp

pcgeffectend:		pop		edi
					pop		esi
				}
			}
			else {
				knj = TXT_RAM[r + TEXT_KNJ];
				if (!(knj & 0x80)) {
					__asm {
						push	esi
						push	edi
						movzx	esi, ank
						mov		edi, v
						movzx	edx, atr
						and		dl, (X1ATR_COLOR or X1ATR_REVERSE)
						movzx	ecx, vramylpcnt
						movzx	eax, byte ptr upt
						and		al, 15
						test	fonttype, ANK_24KHz
						jne		ank24khz
						shl		si, 3
						add		esi, offset ANK_FNT
						call	txt8effects[eax*4]
						jmp		ankputend
ank24khz:				shl		si, 4
						add		esi, offset KNJ_FNT
						call	txt16effects[eax*4]
ankputend:				pop		edi
						pop		esi
					}
				}
				else {
					q = getfontjis(adr2jis_x1t(((WORD)knj << 8) | ank));
					if (knj & 0x40) {
						q++;
					}
					__asm {
						push	esi
						push	edi
						mov		esi, q
						mov		edi, v
						movzx	edx, atr
						and		dl, (X1ATR_COLOR or X1ATR_REVERSE)
						movzx	ecx, vramylpcnt
						movzx	eax, byte ptr upt
						and		al, 15
						test	fonttype, KNJ_24KHz
						jne		knj24khz
						call	knj8effects[eax*4]
						jmp		knjputend
knj24khz:				call	knj16effects[eax*4]
knjputend:				pop		edi
						pop		esi
					}
				}
			}

			__asm {
					push	esi
					push	edi
					movzx	esi, p
					add		esi, dispp
					mov		edi, v
					movzx	ecx, vramylpcnt

grphcpy_lp:			movzx	ebx, byte ptr [esi+PLANE_B]
					mov		eax, grph_x1_table[ebx*4]
					mov		edx, grph_x1_table[ebx*4+256*3*4]
					movzx	ebx, byte ptr [esi+PLANE_R]
					or		eax, grph_x1_table[ebx*4+256*1*4]
					or		edx, grph_x1_table[ebx*4+256*4*4]
					movzx	ebx, byte ptr [esi+PLANE_G]
					or		eax, grph_x1_table[ebx*4+256*2*4]
					or		edx, grph_x1_table[ebx*4+256*5*4]
					or		[edi+SCREEN_WIDTH*0+0], eax
					or		eax, 40404040h
					add		[edi+SCREEN_WIDTH*1+0], eax
					or		[edi+SCREEN_WIDTH*0+4], edx
					or		edx, 40404040h
					add		[edi+SCREEN_WIDTH*1+4], edx
					add		esi, 800h
					add		edi, SCREEN_WIDTH*2
					loop	grphcpy_lp
					pop		edi
					pop		esi
			}
		}
		p++;
		v += 2;
		if (++x >= crtc.TXT_XL) {

			if (updatetmp[p-1] & 4) {					// c{p`悾
				fontycnt += vramylpcnt;
			}
			else {
				fontycnt += vramylpcnt*2;
			}
			fontycnt &= 15;

			v += vramylpad - (x << 1);
			x = 0;
			if (newline) {
				for (i=0; i<vramylpcnt*2; i++) {
					renewalline[y++] |= 3;
				}
				newline = 0;
			}
			else {
				y += vramylpcnt*2;
			}
		}
	}
}


static void width80x12_200line(void) {			// 80x12 15Khz [h

	WORD	p;
	DWORD	*v;
	BYTE	atr, ank, knj;
	int		i;
	BYTE	newline = 0;
	BYTE	x = 0;
	int		y = 0;
	int		times;
	BYTE	*q;
	WORD	r;
	BYTE	upt;

	fontycnt = 0;
	p = crtc.TXT_TOP;
	v = (DWORD *)screenmap;

	times = vramsize;
	while((times--) && (p < (TRAM_MAX/2))) {
		if (updatetmp[p] & dispflg) {
			updatetmp[p] ^= dispflg;
			upt = updatetmp[p];
			newline = 1;
			r = p;
			atr = TXT_RAM[r + TEXT_ATR];
			if (atr & blinktest) {
				atr ^= X1ATR_REVERSE;
			}
			if (upt & 0x10) {
				r--;
			}
			ank = TXT_RAM[r + TEXT_ANK];
			if (TXT_RAM[r + TEXT_ATR] & 0x20) {
				__asm {
					push	esi
					push	edi
					mov		edi, v
					movzx	ecx, vramylpcnt
					text_clear						// ecx = 0 ɂȂ锤

					movzx	esi, ank
					shl		si, 3
					add		esi, offset (pcg.B)
					movzx	eax, byte ptr upt
					and		al, 15
					mov		eax, pcg8effects[eax*4]

					test	atr, 1
					je		pcgplane_red
					mov		edi, v
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 1
					push	eax
					call	eax
					pop		eax

pcgplane_red:		add		si, 256*8
					test	atr, 2
					je		pcgplane_green
					mov		edi, v
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 2
					push	eax
					call	eax
					pop		eax

pcgplane_green:		add		si, 256*8
					test	atr, 4
					je		pcgplane_effect
					mov		edi, v
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 4
					call	eax
pcgplane_effect:							// XLbvCEo[X
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		ebx, 40404040h
					mov		edi, v
					xor		esi, esi
					test	atr, X1ATR_REVERSE
					je		pcgplaneeffectr
					mov		esi, 38383838h
pcgplaneeffectr:	call	pcg_effect12line

					pop		edi
					pop		esi
				}
			}
			else {
				knj = TXT_RAM[r + TEXT_KNJ];
				if (!(knj & 0x80)) {
					__asm {
						push	esi
						push	edi
						movzx	esi, ank
						shl		si, 4
						add		esi, offset KNJ_FNT
						mov		edi, v
						movzx	edx, atr
						and		dl, (X1ATR_COLOR or X1ATR_REVERSE)
						movzx	ecx, vramylpcnt
						movzx	eax, byte ptr upt
						and		al, 15
						call	txt16effects[eax*4]

						mov		cl, vramylpcnt			// ecx = 0̔
						mov		edi, v
						call	text_effect12line

						pop		edi
						pop		esi
					}
				}
				else {
					q = getfontjis(adr2jis_x1t(((WORD)knj << 8) | ank));
					if (knj & 0x40) {
						q++;
					}
					__asm {
						push	esi
						push	edi
						mov		esi, q
						mov		edi, v
						movzx	edx, atr
						and		dl, (X1ATR_COLOR or X1ATR_REVERSE)
						movzx	ecx, vramylpcnt
						movzx	eax, byte ptr upt
						and		al, 15
						call	knj16effects[eax*4]

						mov		cl, vramylpcnt			// ecx = 0̔
						mov		edi, v
						call	text_effect12line

						pop		edi
						pop		esi
					}
				}
			}

			__asm {
					push	esi
					push	edi
					movzx	esi, p
					add		esi, dispp
					mov		edi, v
					mov		cl, vramylpcnt

grphcpy_lp:			movzx	ebx, byte ptr [esi+PLANE_B]
					mov		eax, grph_x1_table[ebx*4]
					mov		edx, grph_x1_table[ebx*4+256*3*4]
					movzx	ebx, byte ptr [esi+PLANE_R]
					or		eax, grph_x1_table[ebx*4+256*1*4]
					or		edx, grph_x1_table[ebx*4+256*4*4]
					movzx	ebx, byte ptr [esi+PLANE_G]
					or		eax, grph_x1_table[ebx*4+256*2*4]
					or		edx, grph_x1_table[ebx*4+256*5*4]
					or		[edi+SCREEN_WIDTH*0+0], eax
					or		eax, 40404040h
					add		[edi+SCREEN_WIDTH*1+0], eax
					or		[edi+SCREEN_WIDTH*0+4], edx
					or		edx, 40404040h
					add		[edi+SCREEN_WIDTH*1+4], edx

					movzx	ebx, byte ptr [esi+PLANE_B + 400h]
					mov		eax, grph_x1_table[ebx*4]
					mov		edx, grph_x1_table[ebx*4+256*3*4]
					movzx	ebx, byte ptr [esi+PLANE_R + 400h]
					or		eax, grph_x1_table[ebx*4+256*1*4]
					or		edx, grph_x1_table[ebx*4+256*4*4]
					movzx	ebx, byte ptr [esi+PLANE_G + 400h]
					or		eax, grph_x1_table[ebx*4+256*2*4]
					or		edx, grph_x1_table[ebx*4+256*5*4]
					or		[edi+SCREEN_WIDTH*2+0], eax
					or		eax, 40404040h
					add		[edi+SCREEN_WIDTH*3+0], eax
					or		[edi+SCREEN_WIDTH*2+4], edx
					or		edx, 40404040h
					add		[edi+SCREEN_WIDTH*3+4], edx

					add		esi, 800h
					add		edi, SCREEN_WIDTH*4
					dec		cl
					jne		grphcpy_lp
					pop		edi
					pop		esi
			}
		}
		p++;
		v += 2;
		if (++x >= crtc.TXT_XL) {

			if (updatetmp[p-1] & 4) {					// c{p`悾
				fontycnt += vramylpcnt;
			}
			else {
				fontycnt += vramylpcnt*2;
			}
			fontycnt &= 15;

			v += vramylpad - (x << 1);
			x = 0;
			if (newline) {
				newline = 0;
				for (i=0; i<vramylpcnt*4; i++) {
					renewalline[y++] |= 3;
				}
			}
			else {
				y += vramylpcnt*4;
			}
		}
	}
}



static void width80x25_400line(void) {			// 80x25 24Khz [h

	WORD	p;
	DWORD	*v;
	BYTE	atr, ank, knj;
	int		i;
	BYTE	newline = 0;
	BYTE	x = 0;
	int		y = 0;
	int		times;
	BYTE	*q;
	WORD	r;
	BYTE	upt;

	fontycnt = 0;
	p = crtc.TXT_TOP;
	v = (DWORD *)screenmap;

	times = vramsize;
	while((times--) && (p < TRAM_MAX)) {
		if (updatetmp[p] & UPDATE_VRAM) {
			updatetmp[p] &= (BYTE)~(UPDATE_VRAM);
			upt = updatetmp[p];
			newline = 1;
			r = p;
			atr = TXT_RAM[r + TEXT_ATR];
			if (atr & blinktest) {
				atr ^= X1ATR_REVERSE;
			}
			if (upt & 0x10) {
				r--;
			}
			ank = TXT_RAM[r + TEXT_ANK];
			if (TXT_RAM[r + TEXT_ATR] & 0x20) {
				__asm {
					push	esi
					push	edi
					mov		edi, v
					movzx	ecx, vramylpcnt
					text_clear						// ecx = 0 ɂȂ锤

					movzx	esi, ank
					shl		si, 3
					add		esi, offset (pcg.B)
					movzx	eax, byte ptr upt
					and		al, 15
					mov		eax, pcg8effects[eax*4]

					test	atr, 1
					je		pcgplane_red
					mov		edi, v
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 1
					push	eax
					call	eax
					pop		eax

pcgplane_red:		add		si, 256*8
					test	atr, 2
					je		pcgplane_green
					mov		edi, v
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 2
					push	eax
					call	eax
					pop		eax

pcgplane_green:		add		si, 256*8
					test	atr, 4
					je		pcgplane_effect
					mov		edi, v
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 4
					call	eax
pcgplane_effect:							// XLbvCEo[X
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 0x40404040
					mov		edi, v
					test	atr, X1ATR_REVERSE
					jne		txtefct_reverse

pcgeffects1_lp:		mov		eax, [edi+SCREEN_WIDTH*0+0]		// m[}
					add		eax, edx
					mov		[edi+SCREEN_WIDTH*1+0], eax
					mov		eax, [edi+SCREEN_WIDTH*0+4]
					add		eax, edx
					mov		[edi+SCREEN_WIDTH*1+4], eax
					add		edi, SCREEN_WIDTH*2
					loop	pcgeffects1_lp
					jmp		pcgeffectend

txtefct_reverse:											// o[X
pcgeffects2_lp:		xor		dword ptr [edi+SCREEN_WIDTH*0+0], 38383838h
					mov		eax, [edi+SCREEN_WIDTH*0+0]
					add		eax, edx
					mov		[edi+SCREEN_WIDTH*1+0], eax
					xor		dword ptr [edi+SCREEN_WIDTH*0+4], 38383838h
					mov		eax, [edi+SCREEN_WIDTH*0+4]
					add		eax, edx
					mov		[edi+SCREEN_WIDTH*1+4], eax
					add		edi, SCREEN_WIDTH*2
					loop	pcgeffects2_lp

pcgeffectend:		pop		edi
					pop		esi
				}
			}
			else {
				knj = TXT_RAM[r + TEXT_KNJ];
				if (!(knj & 0x80)) {
					__asm {
						push	esi
						push	edi
						movzx	esi, ank
						shl		si, 4
						add		esi, offset KNJ_FNT
						mov		edi, v
						movzx	edx, atr
						and		dl, (X1ATR_COLOR or X1ATR_REVERSE)
						movzx	ecx, vramylpcnt
						movzx	eax, byte ptr upt
						and		al, 15
						call	txt16effects[eax*4]
						pop		edi
						pop		esi
					}
				}
				else {
					q = getfontjis(adr2jis_x1t(((WORD)knj << 8) | ank));
					if (knj & 0x40) {
						q++;
					}
					__asm {
						push	esi
						push	edi
						mov		esi, q
						mov		edi, v
						movzx	edx, atr
						and		dl, (X1ATR_COLOR or X1ATR_REVERSE)
						movzx	ecx, vramylpcnt
						movzx	eax, byte ptr upt
						and		al, 15
						call	knj16effects[eax*4]
						pop		edi
						pop		esi
					}
				}
			}
			__asm {
					push	esi
					push	edi
					movzx	esi, p
					mov		edi, v
					mov		cl, vramylpcnt

grphcpy400_lp:		movzx	ebx, byte ptr GRP_00[esi+PLANE_B]
					mov		eax, grph_x1_table[ebx*4]
					mov		edx, grph_x1_table[ebx*4+256*3*4]
					movzx	ebx, byte ptr GRP_00[esi+PLANE_R]
					or		eax, grph_x1_table[ebx*4+256*1*4]
					or		edx, grph_x1_table[ebx*4+256*4*4]
					movzx	ebx, byte ptr GRP_00[esi+PLANE_G]
					or		eax, grph_x1_table[ebx*4+256*2*4]
					or		edx, grph_x1_table[ebx*4+256*5*4]
					or		[edi+SCREEN_WIDTH*0+0], eax
					or		[edi+SCREEN_WIDTH*0+4], edx
					movzx	ebx, byte ptr GRP_01[esi+PLANE_B]
					mov		eax, grph_x1_table[ebx*4]
					mov		edx, grph_x1_table[ebx*4+256*3*4]
					movzx	ebx, byte ptr GRP_01[esi+PLANE_R]
					or		eax, grph_x1_table[ebx*4+256*1*4]
					or		edx, grph_x1_table[ebx*4+256*4*4]
					movzx	ebx, byte ptr GRP_01[esi+PLANE_G]
					or		eax, grph_x1_table[ebx*4+256*2*4]
					or		edx, grph_x1_table[ebx*4+256*5*4]
					or		[edi+SCREEN_WIDTH*1+0], eax
					or		[edi+SCREEN_WIDTH*1+4], edx

					add		esi, 800h
					add		edi, SCREEN_WIDTH*2
					dec		cl
					jne		grphcpy400_lp
					pop		edi
					pop		esi
			}
		}
		p++;
		v += 2;
		if (++x >= crtc.TXT_XL) {

			if (updatetmp[p-1] & 4) {					// c{p`悾
				fontycnt += vramylpcnt;
			}
			else {
				fontycnt += vramylpcnt*2;
			}
			fontycnt &= 15;

			v += vramylpad - (x << 1);
			x = 0;
			if (newline) {
				for (i=0; i<vramylpcnt*2; i++) {
					renewalline[y++] |= 3;
				}
				newline = 0;
			}
			else {
				y += vramylpcnt*2;
			}
		}
	}
}


static void width80x12_400line(void) {			// 80x12 24Khz [h

	WORD	p;
	DWORD	*v;
	BYTE	atr, ank, knj;
	int		i;
	BYTE	newline = 0;
	BYTE	x = 0;
	int		y = 0;
	int		times;
	BYTE	*q;
	WORD	r;
	BYTE	upt;

	fontycnt = 0;
	p = crtc.TXT_TOP;
	v = (DWORD *)screenmap;

	times = vramsize;
	while((times--) && (p < (TRAM_MAX/2))) {
		if (updatetmp[p] & UPDATE_VRAM) {
			updatetmp[p] &= (BYTE)~(UPDATE_VRAM);
			upt = updatetmp[p];
			newline = 1;
			r = p;
			atr = TXT_RAM[r + TEXT_ATR];
			if (atr & blinktest) {
				atr ^= X1ATR_REVERSE;
			}
			if (upt & 0x10) {
				r--;
			}
			ank = TXT_RAM[r + TEXT_ANK];
			if (TXT_RAM[r + TEXT_ATR] & 0x20) {
				__asm {
					push	esi
					push	edi
					mov		edi, v
					movzx	ecx, vramylpcnt
					text_clear						// ecx = 0 ɂȂ锤

					movzx	esi, ank
					shl		si, 3
					add		esi, offset (pcg.B)
					movzx	eax, byte ptr upt
					and		al, 15
					mov		eax, pcg8effects[eax*4]

					test	atr, 1
					je		pcgplane_red
					mov		edi, v
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 1
					push	eax
					call	eax
					pop		eax

pcgplane_red:		add		si, 256*8
					test	atr, 2
					je		pcgplane_green
					mov		edi, v
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 2
					push	eax
					call	eax
					pop		eax

pcgplane_green:		add		si, 256*8
					test	atr, 4
					je		pcgplane_effect
					mov		edi, v
					mov		cl, vramylpcnt			// ecx = 0̔
					mov		edx, 4
					call	eax
pcgplane_effect:							// XLbvCEo[X
					mov		cl, vramylpcnt			// ecx = 0̔
					xor		ebx, ebx
					mov		edi, v
					xor		esi, esi
					test	atr, X1ATR_REVERSE
					je		pcgplaneeffectr
					mov		esi, 38383838h
pcgplaneeffectr:	call	pcg_effect12line

					pop		edi
					pop		esi
				}
			}
			else {
				knj = TXT_RAM[r + TEXT_KNJ];
				if (!(knj & 0x80)) {
					__asm {
						push	esi
						push	edi
						movzx	esi, ank
						shl		si, 4
						add		esi, offset KNJ_FNT
						mov		edi, v
						movzx	edx, atr
						and		dl, (X1ATR_COLOR or X1ATR_REVERSE)
						movzx	ecx, vramylpcnt
						movzx	eax, byte ptr upt
						and		al, 15
						call	txt16effects[eax*4]

						mov		cl, vramylpcnt			// ecx = 0̔
						mov		edi, v
						call	text_effect12line

						pop		edi
						pop		esi
					}
				}
				else {
					q = getfontjis(adr2jis_x1t(((WORD)knj << 8) | ank));
					if (knj & 0x40) {
						q++;
					}
					__asm {
						push	esi
						push	edi
						mov		esi, q
						mov		edi, v
						movzx	edx, atr
						and		dl, (X1ATR_COLOR or X1ATR_REVERSE)
						movzx	ecx, vramylpcnt
						movzx	eax, byte ptr upt
						and		al, 15
						call	knj16effects[eax*4]

						mov		cl, vramylpcnt			// ecx = 0̔
						mov		edi, v
						call	text_effect12line

						pop		edi
						pop		esi
					}
				}
			}

			__asm {
					push	esi
					push	edi
					movzx	esi, p
					mov		edi, v
					mov		cl, vramylpcnt

grphcpy400_lp:		movzx	ebx, byte ptr GRP_00[esi+PLANE_B]
					mov		eax, grph_x1_table[ebx*4]
					mov		edx, grph_x1_table[ebx*4+256*3*4]
					movzx	ebx, byte ptr GRP_00[esi+PLANE_R]
					or		eax, grph_x1_table[ebx*4+256*1*4]
					or		edx, grph_x1_table[ebx*4+256*4*4]
					movzx	ebx, byte ptr GRP_00[esi+PLANE_G]
					or		eax, grph_x1_table[ebx*4+256*2*4]
					or		edx, grph_x1_table[ebx*4+256*5*4]
					or		[edi+SCREEN_WIDTH*0+0], eax
					or		[edi+SCREEN_WIDTH*0+4], edx
					movzx	ebx, byte ptr GRP_00[esi+PLANE_B+0x400]
					mov		eax, grph_x1_table[ebx*4]
					mov		edx, grph_x1_table[ebx*4+256*3*4]
					movzx	ebx, byte ptr GRP_00[esi+PLANE_R+0x400]
					or		eax, grph_x1_table[ebx*4+256*1*4]
					or		edx, grph_x1_table[ebx*4+256*4*4]
					movzx	ebx, byte ptr GRP_00[esi+PLANE_G+0x400]
					or		eax, grph_x1_table[ebx*4+256*2*4]
					or		edx, grph_x1_table[ebx*4+256*5*4]
					or		[edi+SCREEN_WIDTH*1+0], eax
					or		[edi+SCREEN_WIDTH*1+4], edx
					movzx	ebx, byte ptr GRP_01[esi+PLANE_B]
					mov		eax, grph_x1_table[ebx*4]
					mov		edx, grph_x1_table[ebx*4+256*3*4]
					movzx	ebx, byte ptr GRP_01[esi+PLANE_R]
					or		eax, grph_x1_table[ebx*4+256*1*4]
					or		edx, grph_x1_table[ebx*4+256*4*4]
					movzx	ebx, byte ptr GRP_01[esi+PLANE_G]
					or		eax, grph_x1_table[ebx*4+256*2*4]
					or		edx, grph_x1_table[ebx*4+256*5*4]
					or		[edi+SCREEN_WIDTH*2+0], eax
					or		[edi+SCREEN_WIDTH*2+4], edx
					movzx	ebx, byte ptr GRP_01[esi+PLANE_B+0x400]
					mov		eax, grph_x1_table[ebx*4]
					mov		edx, grph_x1_table[ebx*4+256*3*4]
					movzx	ebx, byte ptr GRP_01[esi+PLANE_R+0x400]
					or		eax, grph_x1_table[ebx*4+256*1*4]
					or		edx, grph_x1_table[ebx*4+256*4*4]
					movzx	ebx, byte ptr GRP_01[esi+PLANE_G+0x400]
					or		eax, grph_x1_table[ebx*4+256*2*4]
					or		edx, grph_x1_table[ebx*4+256*5*4]
					or		[edi+SCREEN_WIDTH*3+0], eax
					or		[edi+SCREEN_WIDTH*3+4], edx
					add		esi, 800h
					add		edi, SCREEN_WIDTH*4
					dec		cl
					jne		grphcpy400_lp
					pop		edi
					pop		esi
			}
		}
		p++;
		v += 2;
		if (++x >= crtc.TXT_XL) {

			if (updatetmp[p-1] & 4) {					// c{p`悾
				fontycnt += vramylpcnt;
			}
			else {
				fontycnt += vramylpcnt*2;
			}
			fontycnt &= 15;

			v += vramylpad - (x << 1);
			x = 0;
			if (newline) {
				for (i=0; i<vramylpcnt*4; i++) {
					renewalline[y++] |= 3;
				}
				newline = 0;
			}
			else {
				y += vramylpcnt*4;
			}
		}
	}
}



void palettes(void) {

	int		i, j;
	BYTE	GRPH_PAL[8];
	BYTE	bit;
	BYTE	c;
	BYTE	skipcol = 0;
	BYTE	skiptxt = 0;

	if ((xmilcfg.SKIP_LINE) && (!(crtc.SCRN_BITS & 1))) {
		skipcol = 16;
		skiptxt = 8;
	}

	for (i=0, bit=1; i<8; i++, bit<<=1) {
		c = 0;
		if (crtc.PAL_B & bit) {
			c |= 1;
		}
		if (crtc.PAL_R & bit) {
			c |= 2;
		}
		if (crtc.PAL_G & bit) {
			c |= 4;
		}
		GRPH_PAL[i] = c;
	}

	for (i=0, bit=1; i<8; i++, bit<<=1) {
		c = GRPH_PAL[i];
		xm_palette[i].d = degitalpal[c];
		xm_palette[i+64].d = degitalpal[c + skipcol];
		xm_palette[i+128].d = degitalpal[c + skipcol];
		if (crtc.PLY & bit) {
			for (j=i+8; j<64; j+=8) {
				xm_palette[j].d = degitalpal[c];
				xm_palette[j+64].d = degitalpal[c + skipcol];
				xm_palette[j+128].d = degitalpal[c + skipcol];
			}
		}
		else {
			for (j=i+8; j<64; j+=8) {
				c = crtc.TEXT_PAL[j>>3];
				xm_palette[j].d = degitalpal[c];
				xm_palette[j+64].d = degitalpal[c+skiptxt];
				xm_palette[j+128].d = degitalpal[c+skipcol];
			}
		}
	}
	change_palette();
}


static void x1vram_adjust(void) {

	BYTE	maxline;

	if (crtc.TXT_XL <= 40) {
		change_xmode(1);
	}
	else {
		change_xmode(0);
	}
	if (crtc.SCRN_BITS & 4) {
		vramylpcnt = (crtc.FNT_YL >> 1) & 0xfffc;
		if (vramylpcnt >= 8) {
			vramylpcnt = 8;
		}
		vramylpad = vramylpcnt * (SCREEN_WIDTH / 4) * 4;
		maxline = (BYTE)100 / vramylpcnt;
		if (maxline > crtc.TXT_YL) {
			maxline = crtc.TXT_YL;
		}
		vramsize = maxline * crtc.TXT_XL;
		drawlines = maxline * vramylpcnt * 2;
	}
	else {
		vramylpcnt = crtc.FNT_YL & 0xfffc;
		if (vramylpcnt >= 8) {
			vramylpcnt = 8;
		}
		vramylpad = vramylpcnt * (SCREEN_WIDTH / 4) * 2;
		maxline = (BYTE)200 / vramylpcnt;
		if (maxline > crtc.TXT_YL) {
			maxline = crtc.TXT_YL;
		}
		vramsize = maxline * crtc.TXT_XL;
		drawlines = maxline * vramylpcnt;
	}
	change_drawlines(drawlines*2);
	if (vramsize >= (0x800 - crtc.TXT_TOP)) {
		vramsize = 0x800 - crtc.TXT_TOP;
	}
}

// -------------------------------------------------------------------------

static void (*screendraw[8])(void) = {
				width80x25_200line, width80x25_400line,
				width80x25_200line, width80x25_200line,
				width80x12_200line, width80x12_400line,
				width80x12_200line, width80x12_200line};


void scrnupdate(void) {

	if ((lastdisp ^ crtc.SCRN_BITS) & 0x08) {
		lastdisp = crtc.SCRN_BITS;
		scrnallflash = 1;
		if (crtc.SCRN_BITS & 0x08) {
			dispp = GRP_01;
			dispflg = UPDATE_VRAM1;
		}
		else {
			dispp = GRP_00;
			dispflg = UPDATE_VRAM0;
		}
	}
	if (scrnallflash) {
		scrnallflash = 0;
		fillupdatetmp();
		x1vram_adjust();
		scrnflash = 1;
	}
	if (doubleatrchange) {
		flashupdatetmp();
		doubleatrchange = 0;
	}
	if (palandply) {
		palandply = 0;
		palettes();
		ddrawflash = 1;
	}
	if (blinkflag) {
		updateblink();
	}
	if (scrnflash) {
		scrnflash = 0;
		screendraw[crtc.SCRN_BITS & 7]();
		ddrawflash = 1;
	}
	if (ddrawflash) {
		ddrawflash = 0;
		scrn_draws();
		scrn_drawall();
	}
	else {
		ddrawflash = scrn_restore();
	}
}



void scrnupdate1line(DWORD line) {

	if (line < drawlines) {
		if (palandply) {
			palandply = 0;
			palettes();
			ddrawflash = 1;
		}
		ddrawflash |= scrn_draw1(line*2);
		ddrawflash |= scrn_draw1(line*2+1);
	}
}

void scrnupdatelast(void) {

	if (ddrawflash) {
		ddrawflash = 0;
		scrn_drawall();
	}
	if ((lastdisp ^ crtc.SCRN_BITS) & 0x08) {
		lastdisp = crtc.SCRN_BITS;
		scrnallflash = 1;
		if (crtc.SCRN_BITS & 0x08) {
			dispp = GRP_01;
			dispflg = UPDATE_VRAM1;
		}
		else {
			dispp = GRP_00;
			dispflg = UPDATE_VRAM0;
		}
	}
	if (scrnallflash) {
		scrnallflash = 0;
		fillupdatetmp();
		x1vram_adjust();
		scrnflash = 1;
	}
	if (doubleatrchange) {
		flashupdatetmp();
		doubleatrchange = 0;
	}
	if (blinkflag) {
		updateblink();
	}
	if (scrnflash) {
		scrnflash = 0;
		screendraw[crtc.SCRN_BITS & 7]();
		ddrawflash = 1;
	}
	else {
		ddrawflash = scrn_restore();
	}
}

