#include	<windows.h>
#include	<stdio.h>
#include	<string.h>
#include	"xmil.h"
#include	"x1.h"
#include	"x1_scpu.h"
#include	"x1_8255.h"
#include	"x1_pcg.h"
#include	"x1_crtc.h"
#include	"x1_vram.h"
#include	"x1_fdc.h"
#include	"x1_dma.h"
#include	"x1_dmam.h"
#include	"x1_ctc.h"
#include	"x1_clndr.h"
#include	"x1_sio.h"
#include	"x1_sound.h"
#include	"input.h"
#include	"draw.h"
#include	"timer.h"
#include	"dosio.h"
#include	"trace.h"
#include	"dsounds.h"
#include	"menu.h"

	X1_FLAG		x1flg = {250, 0, 1, 1, 0};
	BYTE		mMAIN[0x10000];
	BYTE		mBIOS[0x8000];
	BYTE		mBANK[32][0x8000];
	BYTE		KNJ_FNT[0x4bc00];
	BYTE		GRP_00[0xc000];
	BYTE		GRP_01[0xc000];
	BYTE		TXT_RAM[0x1800];
	WORD		v_cnt;

	BYTE		*RAM0r;
	BYTE		*RAM0w;


/***********************************************************************
	IPL-ROM LOAD
***********************************************************************/

const	BYTE	IPLFILE[] = "IPLROM.X1";
const	BYTE	TURBOIPLFILE[] = "IPLROM.X1T";

void ipl_load(void) {

		FILEH	hdl;
extern	BYTE	DEFROM[];

	ZeroMemory(mBIOS, sizeof(mBIOS));
	memcpy(mBIOS, DEFROM, 575);

	if (x1flg.ROM_TYPE == 2) {
		if ((hdl = file_open_c((LPSTR)TURBOIPLFILE)) != (FILEH)-1) {
			file_read(hdl, mBIOS, 0x8000);
			file_close(hdl);
		}
	}
	else if (x1flg.ROM_TYPE == 1) {
		if ((hdl = file_open_c((LPSTR)IPLFILE)) != (FILEH)-1) {
			file_read(hdl, mBIOS, 0x8000);
			file_close(hdl);
		}
	}
}


/***********************************************************************
	FONT-ROM LOAD
***********************************************************************/

void fnt_load(void) {

	FILEH	fh;

	if ((fh = file_open_c("FNT0808.X1")) != (FILEH)-1) {
		file_read(fh, ANK_FNT[0], 8*256);
		file_close(fh);
	}

	if ((fh = file_open_c("FNT0816.X1")) != (FILEH)-1) {
		file_read(fh, KNJ_FNT, 0x1000);
		file_close(fh);
	}
	if ((fh = file_open_c("FNT1616.X1")) != (FILEH)-1) {
		file_lread(fh, &KNJ_FNT[0x1000], 0x4ac00);
		file_close(fh);
	}
}


/***********************************************************************
	
***********************************************************************/

void reset_x1(BYTE ROM_TYPE, BYTE SOUND_SW, BYTE DIP_SW) {

	x1_psg_reset();
	x1_opm_reset();

	x1flg.HSYNC_CLK = 250;
	x1flg.ROM_SW = 1;
	x1flg.ROM_TYPE = ROM_TYPE;
	x1flg.SOUND_SW = SOUND_SW;
	x1flg.DIP_SW = DIP_SW;

	textdrawproc_renewal();
	ipl_load();
#if 0
	x1_mem_init();
	x1_memset_bios();
#else
	RAM0r = mBIOS;
	RAM0w = mMAIN;
#endif


	Z80_Reset();
	clndr_init();

	init_fdc();
	init_scpu();
	init_8255();
	init_crtc();
	init_vram();

	init_dma();
	init_ctc();
	init_pcg();
}



/***********************************************************************
	s^I
***********************************************************************/

static	BYTE	keyintcnt = 0;
static	BYTE	flame = 0;
static	BYTE	inttiming = 0;

void x1r_init(void) {

	TRACE_START();

	init_draw();
	fnt_load();
	reset_x1(xmilcfg.ROM_TYPE, xmilcfg.SOUND_SW, xmilcfg.DIP_SW);

	v_cnt = 0;
	timer_init(60);

	x1_psg_cont();
	x1_opm_cont();
	keyboard_init();
	keyboard_reset();
	timer_setcount(0);
}


void x1r_exec(void) {						// Sound Normal Priority 4MHz

	v_cnt = 0;

	while(v_cnt < 266) {
		while(h_cnt < x1flg.HSYNC_CLK) {
			Z80_Execute();
			Z80_Execute();
			x1_dma();
		}
		h_cnt -= x1flg.HSYNC_CLK;
		x1_ctc_int();
		if (!((++keyintcnt) & 15)) {// 9600bps(K)/10bit/60fps/266׽
			x1_sub_int();			// 1/16 炢^^;
		}
		v_cnt++;
		if (crtc.CRT_YL == v_cnt) {
			pcg.vsync = 1;
		}
	}
	if (++flame >= 60) {
		flame = 0;
		clndr_inc();
	}
	STREAM_MAKES(framesoundcnt);
}



void x1r_exec_8mhz(void) {					// Sound Normal Priority 8MHz

	v_cnt = 0;

	while(v_cnt < (266*2)) {
		while(h_cnt < x1flg.HSYNC_CLK) {
			Z80_Execute();
			Z80_Execute();
			x1_dma();
		}
		h_cnt -= x1flg.HSYNC_CLK;
		if ((++inttiming) & 1) {
			x1_ctc_int();
			if (!((++keyintcnt) & 15)) {
				x1_sub_int();
			}
		}
		v_cnt++;
		if (crtc.CRT_YL == v_cnt) {
			pcg.vsync = 1;
		}
	}
	if (++flame >= 60) {
		flame = 0;
		clndr_inc();
	}
	STREAM_MAKES(framesoundcnt);
}

void x1r_exec_shp(void) {					// Sound High Priority 4MHz

	v_cnt = 0;

	while(v_cnt < 266) {
		while(h_cnt < x1flg.HSYNC_CLK) {
			Z80_Execute();
			Z80_Execute();
			x1_dma();
		}
		h_cnt -= x1flg.HSYNC_CLK;
		x1_ctc_int();
		if (!((++keyintcnt) & 15)) {
			x1_sub_int();
		}
		STREAM_MAKES(pcmbufsize[v_cnt]);
		v_cnt++;
		if (crtc.CRT_YL == v_cnt) {
			pcg.vsync = 1;
		}
	}
	if (++flame >= 60) {
		flame = 0;
		clndr_inc();
	}
}


void x1r_exec_shp8mhz(void) {				// Sound High Priority 8MHz

	v_cnt = 0;

	while(v_cnt < (266*2)) {
		while(h_cnt < x1flg.HSYNC_CLK) {
			Z80_Execute();
			Z80_Execute();
			x1_dma();
		}
		h_cnt -= x1flg.HSYNC_CLK;
		if ((++inttiming) & 1) {
			STREAM_MAKES(pcmbufsize[v_cnt>>1]);
			x1_ctc_int();
			if (!((++keyintcnt) & 15)) {
				x1_sub_int();
			}
		}
		v_cnt++;
		if (crtc.CRT_YL == v_cnt) {
			pcg.vsync = 1;
		}
	}
	if (++flame >= 60) {
		flame = 0;
		clndr_inc();
	}
}



void x1r_exec_p(void) {						// Pal Sound Normal Priority 4MHz

	v_cnt = 0;

	while(v_cnt < 266) {
		while(h_cnt < x1flg.HSYNC_CLK) {
			Z80_Execute();
			Z80_Execute();
			x1_dma();
		}
		h_cnt -= x1flg.HSYNC_CLK;
		x1_ctc_int();
		if (!((++keyintcnt) & 15)) {// 9600bps(K)/10bit/60fps/266׽
			x1_sub_int();			// 1/16 炢^^;
		}
		scrnupdate1line(v_cnt++);
		if (crtc.CRT_YL == v_cnt) {
			pcg.vsync = 1;
		}
	}
	if (++flame >= 60) {
		flame = 0;
		clndr_inc();
	}
	STREAM_MAKES(framesoundcnt);
}



void x1r_exec_p8mhz(void) {					// Pal Sound Normal Priority 8MHz

	v_cnt = 0;

	while(v_cnt < (266*2)) {
		while(h_cnt < x1flg.HSYNC_CLK) {
			Z80_Execute();
			Z80_Execute();
			x1_dma();
		}
		h_cnt -= x1flg.HSYNC_CLK;
		if ((++inttiming) & 1) {
			x1_ctc_int();
			if (!((++keyintcnt) & 15)) {
				x1_sub_int();
			}
		}
		scrnupdate1line(v_cnt++);
		if (crtc.CRT_YL == v_cnt) {
			pcg.vsync = 1;
		}
	}
	if (++flame >= 60) {
		flame = 0;
		clndr_inc();
	}
	STREAM_MAKES(framesoundcnt);
}

void x1r_exec_pshp(void) {					// Pal Sound High Priority 4MHz

	v_cnt = 0;

	while(v_cnt < 266) {
		while(h_cnt < x1flg.HSYNC_CLK) {
			Z80_Execute();
			Z80_Execute();
			x1_dma();
		}
		h_cnt -= x1flg.HSYNC_CLK;
		x1_ctc_int();
		if (!((++keyintcnt) & 15)) {
			x1_sub_int();
		}
		STREAM_MAKES(pcmbufsize[v_cnt]);
		scrnupdate1line(v_cnt++);
		if (crtc.CRT_YL == v_cnt) {
			pcg.vsync = 1;
		}
	}
	if (++flame >= 60) {
		flame = 0;
		clndr_inc();
	}
}


void x1r_exec_pshp8mhz(void) {				// Pal Sound High Priority 8MHz

	v_cnt = 0;

	while(v_cnt < (266*2)) {
		while(h_cnt < x1flg.HSYNC_CLK) {
			Z80_Execute();
			Z80_Execute();
			x1_dma();
		}
		h_cnt -= x1flg.HSYNC_CLK;
		if ((++inttiming) & 1) {
			STREAM_MAKES(pcmbufsize[v_cnt>>1]);
			x1_ctc_int();
			if (!((++keyintcnt) & 15)) {
				x1_sub_int();
			}
		}
		scrnupdate1line(v_cnt++);
		if (crtc.CRT_YL == v_cnt) {
			pcg.vsync = 1;
		}
	}
	if (++flame >= 60) {
		flame = 0;
		clndr_inc();
	}
}



void x1r_term(void) {

	timer_term();
	x1_opm_stop();
	x1_psg_stop();
	keyboard_term();
	TRACE_END();

	x1_set_fd(0, 0, NULL);
	x1_set_fd(1, 0, NULL);
	x1_set_fd(2, 0, NULL);
	x1_set_fd(3, 0, NULL);
}

X1_IOR x1_dipsw_r(WORD port) {

	if (x1flg.ROM_TYPE != 2) {
		return(-1);
	}
	return(x1flg.DIP_SW);
}
