#include	"z80.h"
#include	"x1_io.h"
#include	"x1_mem.h"

typedef struct {
	WORD	HSYNC_CLK;
	BYTE	ROM_TYPE;
	BYTE	ROM_SW;
	BYTE	DIP_SW;
	BYTE	SOUND_SW;
} X1_FLAG;

extern	X1_FLAG	x1flg;
extern	BYTE	*RAM0r;
extern	BYTE	*RAM0w;

extern	BYTE	mMAIN[0x10000];
extern	BYTE	mBIOS[0x8000];
extern	BYTE	mBANK[32][0x8000];
extern	BYTE	ANK_FNT[256][8];
extern	BYTE	KNJ_FNT[0x4bc00];
extern	BYTE	GRP_00[0xc000];
extern	BYTE	GRP_01[0xc000];
extern	BYTE	TXT_RAM[0x1800];

#define	TEXT_ANK	0x0000
#define	TEXT_ATR	0x0800
#define	TEXT_KNJ	0x1000

#define	PLANE_B		0x0000
#define	PLANE_R		0x4000
#define	PLANE_G		0x8000

#define	h_cnt	Z80_ICount
extern	WORD	v_cnt;

void reset_x1(BYTE ROM_TYPE, BYTE SOUND_SW, BYTE DIP_SW);

void x1r_init(void);
void x1r_term(void);

void x1r_exec(void);
void x1r_exec_8mhz(void);
void x1r_exec_shp(void);
void x1r_exec_shp8mhz(void);

void x1r_exec_p(void);
void x1r_exec_p8mhz(void);
void x1r_exec_pshp(void);
void x1r_exec_pshp8mhz(void);

X1_IOR x1_dipsw_r(WORD port);
