#include	<windows.h>
#include	<stdio.h>
#include	"x1.h"
#include	"x1_crtc.h"
#include	"x1_pcg.h"
#include	"x1_vram.h"
#include	"draw.h"

		CRTC_TABLE	crtc;

const	CRTC_TABLE	crtcdefault = {
				0xaa,						// PAL_B;
				0xcc,						// PAL_R;
				0xf0,						// PAL_G;
				0x00,						// PLY
				{0, 1, 2, 3, 4, 5, 6, 7},	// TEXT_PAL[8]
				0,							// SCRN_BITS
				0,							// CRTC_NUM

				0,							// DISP_PAGE
				8,							// FNT_XL
				8,							// FNT_YL
				40,							// TXT_XL
				25,							// TXT_YL
				28,							// TXT_YS
				320,						// GRP_XL
				200,						// GRP_YL
				0,							// CPU_BANK
				0,							// CRT_BANK

				200,						// CRT_YL
				232,						// CRT_VS
				266,						// CRT_VL

				31,							// TXT_VL
				10,							// TXT_VLA

				0,							// TXT_TOP
				8,							// fnty
	};



/***********************************************************************
	
***********************************************************************/

void init_crtc(void) {

	crtc = crtcdefault;

	palandply = 1;

	if ((x1flg.ROM_TYPE == 2) && (!(x1flg.DIP_SW & 1))) {
		crtc.SCRN_BITS = 0x02;
		crtc.FNT_YL = 16;
	}

	vrambank_patch(0);
	scrnallflash = 1;
}

void crtc_updt(void) {

	if (crtc.SCRN_BITS & 1) {
		crtc.fnty = (crtc.FNT_YL >> 1) & 0xfffc;
	}
	else {
		crtc.fnty = crtc.FNT_YL  & 0xfffc;
	}
	crtc.CRT_YL = crtc.fnty * crtc.TXT_YL;
	crtc.CRT_VS = crtc.fnty * (crtc.TXT_YS + 1);
	crtc.CRT_VL = (crtc.TXT_VL + 1) * crtc.fnty + crtc.TXT_VLA;
}

/***********************************************************************
	CRTC
***********************************************************************/

X1_IOW x1_crtc_reg(WORD port, BYTE value) {

	crtc.CRTC_NUM = value;
}

X1_IOW x1_crtc_dat(WORD port, BYTE value) {

	switch(crtc.CRTC_NUM) {
		case  1:
			if (value <= 40) {
				crtc.TXT_XL = 40;
			}
			else {
				crtc.TXT_XL = 80;
			}
			break;
		case  4:
			crtc.TXT_VL = value;
			break;
		case  5:
			crtc.TXT_VLA = value;
			break;
		case  6:
			crtc.TXT_YL = value;
			break;
		case  7:
			crtc.TXT_YS = value;
			break;
		case  9:
			crtc.FNT_YL = (WORD)value+1;
			break;
		case 12:
			*(((BYTE *)&crtc.TXT_TOP)+1) = (BYTE)(value & 7);
			doubleatrchange = 1;
			break;
		case 13:
			*(BYTE *)&crtc.TXT_TOP = value;
			doubleatrchange = 1;
			break;
		default:
			return;
	}
	crtc.GRP_XL = crtc.TXT_XL << 3;
	crtc.GRP_YL = 200;
	crtc_updt();
	scrnallflash = 1;								/* 990220 puni */
}

/***********************************************************************
	PALLET
***********************************************************************/

X1_IOW x1_palet_w(WORD port, BYTE value) {

	switch(port & 0xff00) {
		case 0x1000:
			if (crtc.PAL_B != value) {
				crtc.PAL_B = value;
				palandply = 1;
			}
			break;
		case 0x1100:
			if (crtc.PAL_R != value) {
				crtc.PAL_R = value;
				palandply = 1;
			}
			break;
		case 0x1200:
			if (crtc.PAL_G != value) {
				crtc.PAL_G = value;
				palandply = 1;
			}
			break;
	}
}

X1_IOW x1_palet_patch(WORD port, BYTE value) {

	BYTE	blue = 0;

	if (value != 9) {
		blue = 1;
	}
	if (crtc.TEXT_PAL[1] != blue) {
		crtc.TEXT_PAL[1] = blue;
		palandply = 1;
	}
}


/***********************************************************************
	ײè
***********************************************************************/

X1_IOW x1_ply_w(WORD port, BYTE value) {

	if (crtc.PLY != value) {
		crtc.PLY = value;
		palandply = 1;
	}
}

X1_IOR x1_ply_r(WORD port) {

	return(crtc.PLY);
}


/***********************************************************************
	 
***********************************************************************/

X1_IOW x1_scrn_w(WORD port, BYTE value) {

	BYTE	scrnbitsbak = crtc.SCRN_BITS;

	if (x1flg.ROM_TYPE != 2) {
		value = 0;								// 
	}
	crtc.SCRN_BITS = value;
	if ((crtc.SCRN_BITS ^ scrnbitsbak) & 7) {
		textdrawproc_renewal();
		reflesh_palette();
		scrnallflash = 1;
		palandply = 1;
		crtc_updt();
	}
	vrambank_patch(value);
	crtc.CPU_BANK = (BYTE)((crtc.SCRN_BITS & 0x10)?1:0);
	crtc.CRT_BANK = (BYTE)((crtc.SCRN_BITS & 0x08)?1:0);
}

X1_IOR x1_scrn_r(WORD port) {

	if (x1flg.ROM_TYPE != 2) {
		return(0xff);
	}
	return(crtc.SCRN_BITS);
}

